<script setup lang="ts">
import { useSalaryStore } from '@/stores/salary'
import { useUserStore } from '@/stores/user'
import DialogSalary from './DialogSalary.vue'
import ReportSalaryDialog from './ReportSalaryDialog.vue'


import { ref, computed } from 'vue'

const salaryStore = useSalaryStore()
const userStore = useUserStore()
const currentDate = new Date();
const currentMonth = currentDate.toLocaleString('default', { month: 'long' });


const search = ref('')
const headers = [
  { key: 'idSalary', sortable: false, title: 'Salary Id' },
  { key: 'fullname', title: 'Fullname', sortable: false },
  { key: 'role', title: 'Role', sortable: false },
  { key: 'status', title: 'Status', sortable: false },
  { key: 'actions', title: 'Actions', sortable: false },
]

const combinedItems = computed(() => {
  return [
    ...userStore.users.map((user) => ({
      ...user,
      ...(salaryStore.salarys.find((salarys) => salarys.idSalary === user.id) || {
        idSalary: salaryStore.lastIndex++,
        salarybaht: user.role === 'manager' ? 25000 : 15000,
        month: currentMonth,
        status: ' Not Paid ',
        userId: user.id,
        user: user
      })
    }))
  ]
})


</script>
<template>
  
  <v-data-table :headers="headers" :items-per-page="8" :items="combinedItems" :search="search" style="background-color: #E7D0B9;">
    <template v-slot:[`item.actions`]="{ item }">
      <v-icon size="large" class="me-2" @click="salaryStore.editItem(item)"> mdi-cash </v-icon>
      </template>
      
  </v-data-table>

  <DialogSalary></DialogSalary>
  <ReportSalaryDialog></ReportSalaryDialog>
</template>
<style scoped>
tbody tr:nth-of-type(even) {
  background-color: #D2BAA0;
}

tbody tr:nth-of-type(odd) {
  background-color: #E7D0B9;
}

thead {
  background-color: #BC9B6B;
  color: rgb(0, 0, 0);
  font-weight: bold;
}


.theme--light.v-data-table thead tr th {
  color: white;
}
</style>
